#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_check.pl
#
#  Author:  Bill Border
#
#    Note:  
# !*-------------------------------------------------------------------------
# Changes:
#   27Jan05 bb - If the REMOTE_HOST is null, DON'T pass the ? 
#   01Apr11 bb - Major changes
#----------------------------------------------------------------------------
$| = 1;
$P = "dbamon_magnify_run.pl";

push(@INC,"/opt/dbamon/lib");

require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";
require "cgi_handlers.pl";

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#---- Read WWW_Font:
$font = &readRC("WWW_Font:");
## &msg("DEBUG - font=$font"); 

#---- Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n"; 
}

#------------------------------------------------------------------------------
#
# Main  
#
#------------------------------------------------------------------------------

# #
# # Get form data
# #
# &get_request;
# $pw = $rqpairs{'pw'};
# print "pw=$pw \n";

@words = split(/,/,$ARGV[0]);
$verb    = $words[0];
$mode    = $words[1];
$instnum = $words[2];
$ck      = $words[3];
$title   = $words[4];
$dbms    = $words[5];
$action  = $words[6];
$confirm = $words[7];

if ($verb eq "PTEST") 
{
  &msg("Exiting");  
  exit 0; 
}

$dbms = "OracleUX" if $dbms eq "";

if ($dbms eq "oracledbnt")
{
  if (length($verb) > 3)
  {
    $dis = "orantadmin $verb";
  }
  else
  {
    $dis = "orantstat $verb";
  }
}
elsif ($dbms eq "oracledbux")
{
  if (length($verb) > 3)
  {
    $dis = "oraadmin $verb";
  }
  else
  {
    $dis = "orastat $verb";
  }
}
else
{
  $dis = "AutoCmd: $verb";
}

&header("Magnify - $dis - $title"); 
&msg("Starting - verb=$verb mode=$mode title=$title dbms=$dbms"); 

chop($host = `hostname`);
##chop($dbamonid = `ls -l /opt/dbamon/adm/dbamonrc | awk '{ print \$3 }'`);
##$logfile = "/opt/dbamon/log/dbamon_magnify.log";

if ($ENV{'REMOTE_HOST'}) 
{
  $zclient = $ENV{'REMOTE_HOST'};
}
elsif ($ENV{'REMOTE_ADDR'})
{
  $zclient = $ENV{'REMOTE_ADDR'};
}
else
{
  $zclient = "UnknownClient";
}

##system("env > /tmp/magnify_env.txt");
##chop($date = `date +%Y/%m/%d-%H:%M:%S`);
##system("echo ' ' | mailx -s '$P.pl ($zclient) $verb' bill_border\@thecompany.com");
##system("echo '$date - $P $zclient $verb $title $dbms $action $dis' >> /tmp/dbamon_magnify_run.log");
##system("echo '$date - $P $zclient $verb $title' >> $logfile 2>/dev/null");

if ($ENV{"HTTP_USER_AGENT"} =~ /HP-UX/) { $browser = "NS"; }
else                                    { $browser = "IE"; }

#---- Graphs
if ($action eq "G")
{
  ##$graph_type = "GHOURLY"; 
  $graph_type = "GDAILY"; 
  ##&msg("GraphCreate - verb=$verb graph_type=$graph_type"); 

  if    ($verb eq "g01") { $graph_string = "PERF_SQL_RATETRANSPERSEC,."; }
  elsif ($verb eq "g02") { $graph_string = "PERF_SYS_CPUTOTALBUSYPCT,."; }
  elsif ($verb eq "g03") { $graph_string = "PERF_SQL_PAGELIFEEXPECTANCY,."; }
  elsif ($verb eq "g04") { $graph_string = "PERF_SQL_PROCESSESBLOCKED,."; }
  elsif ($verb eq "g05") { $graph_string = "PERF_SQL_BUFFERCACHEHITRATIO,."; }
  elsif ($verb eq "g06") { $graph_string = "PERF_SYS_MEMUSEDPCT,."; }
  elsif ($verb eq "g07") { $graph_string = "PERF_SYS_DISKPHYSAVGQUEUELEN,."; }
  elsif ($verb eq "g08") { $graph_string = "PERF_SYS_DISKPHYSAVGRTMS,."; }

  elsif ($verb eq "g90") { $graph_type = "MSSQL_INSTANCE_SIZE"; }

  else    { &error("Graph verb=$verb is NOT DEFINED"); }

  ##$cmd ="   http://localhost/cgi-bin/dbamon_metrics.pl?prod,GHOURLY,localhost_MSSQL1,PERF_SQL_TRANSRATE,. "; 
  $cmd ="./dbamon_metrics.pl $mode,$graph_type,$title,$graph_string "; 
  &msg("Invoking dbamon_metrics.pl to create graph - cmd=$cmd"); 
  $ENV{'DBAMON_NOWEB'} = 1;
  system("$cmd 2>&1"); 

  $goback = -2;
  print "<script language='JavaScript'>
    function back() { history.go($goback); }
  </script>";
  exit;
}

#---- Actions
if ($action eq "A" && $confirm ne "YES")
{
  chop($fqhost = `nslookup $host | grep Name: | awk '{ print \$2 }'`);
  print "<script language='JavaScript'>
    input_box = confirm('Are you sure that you want to run $dis on $title?');
    if (input_box==true)
    {
      location = 'http://$fqhost/cgi-bin/$P?$verb,$mode,$instnum,$ck,$title,$dbms,$action,YES';
    }
    else
    {
      history.go(-1);
    }
  </script>\n";
  exit;
}

##$cmd = "remsh $host -l $dbamonid '/opt/dbamon/bin/dbamon_www_magnify.pl $verb $mode $instnum $ck $browser $zclient $action $title'";
$cmd = "/opt/dbamon/bin/dbamon_www_magnify.pl $verb $mode $instnum $ck $browser $zclient $action $title";
&msg("Invoking $cmd - client=$zclient");

#print "<pre>\n";
$s_time = time;
$rc = system("$cmd 2>&1");
$e_time = time;
$rc /= 256 if $rc != 0;

$elapsed = $e_time - $s_time;
&msg("dbamon_www_magnify.pl rc=$rc - Execution elapsed time: $elapsed second(s)");

print "</pre><hr><font face=$font color=black>\n";
#Click <b>Back</b> to return to Magnify Menu\n";

if    ($action eq "D") { $goback = "-1"; }
elsif ($action eq "A") { $goback = "-2"; }
print "<script language='JavaScript'>
  function back() { history.go($goback); }
</script>";

#print "<b><a href='javascript:back()'>Click Here</a> to return to the previous page.</b>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "<font size=2><b>DBAmon Links:</font></b>
</table>
<table width=750>

 $links_include

</table>
<hr>
";

exit 0;
