#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_rpt.pl
# !*-------------------------------------------------------------------------

$P = "dbamon_rpt.pl";
$| = 1;
require "cgi_handlers.pl";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

# General parms required
$date          = `date`;

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}


$data_source = "dbi:mysql";
$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  ##print "</center><br><font size=2>$date ${P} | <b>$msgmsg</b></font><center>\n";
  print "<br><font size=1>$date ${P} | <b>$msgmsg</b></font>\n";
}


#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "<hr>";
   print "<h4> The following database error occured:</h4>";
   print "    <b> Error ID: </b> $errorMsg";
   $sqlerror = $DBI::errstr;
   print "<br><b>SQL Statement: </b> <pre> $statement </pre>";
   print "<br><b>SQL Error: </b> $sqlerror";
   print "<hr>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub report_text
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $days = $arg1;

  # Create the SQL SELECT statement
  $statement  = "select
    system,
    instance,
    text,
    to_char(ts,'YYYY/MM/DD-HH24:MI:SS')
  from 
    dbamon.text
  where 
    ts >= (sysdate - $days)
  order by 
    system, 
    instance, 
    seq";

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  print "<h4>DBAmon Text Entries That Have Changed Within The Last $days Day(s)</h4>\n";
  print "<table border=1>\n";
  #print "
  #<tr bgcolor=slate> 
  #  <th><h6>System-Instance 
  #  <th><h6>Text
  #";

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $system   = $Data[0];
    $instance = $Data[1];
    $text     = $Data[2];
    $ts       = $Data[3];

    $title1 = $system . "-" . $instance;
    $title1 =~ s/ //g;

    if ($title1 ne $last_title1)
    {
      print "
      <tr bgcolor=black>
	<td colspan=4><h5><center><font color=lightblue>Instance: $title1</font></center>";
	#<td colspan=4><h5><center>Instance: $title1</center>";
    }

    #print "system=$system instance=$instance text=$text ts=$ts\n";
      #<td bgcolor=lightblue nowrap><h6>$title1
    print "
    <tr bgcolor=lightgrey>
      <td bgcolor=wheat><h5>$text
      ";
    $last_title1 = $title1; 
  }
  print" </table> \n";
  print "<p><font size=1>(Selected $selectcount Rows)</font><hr>";
}

#-----------------------------------------------------------------------------
sub report_oraservers_text
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "select distinct rmt_hostname || '.' || rmt_domain \"hostname\" from dbamon.summary_detail where dbms='OracleDB-UX' or dbms='Informix-UX'" ; 

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  #print "<table border=1> \n";
  #print "<tr bgcolor=slate><th><h6>Server<th><h6>Instance<br>Count\n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $system   = $Data[0];

    $total_count += $count;

    print "$system<br>\n";
  }

 #print "<tr bgcolor=slate><td><b><font size=2>Total:<font><td align=right><font size=2><b>$total_count</b></font>\n";
 #print "</table> \n";

 #print "<font size=2><p><b>Total Servers Housing Oracle/UX Instances: $total</b></font>";
  
 #print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_cpucount
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  $mode = "prod";
  print "<font size=1>$d - Creating Report (mode=$mode)...</font>\n";

  $sql = "
    select
      dbms,
      count(*) servercount,
      sum(a.cpucount)
    from
      (select distinct
	 dbms,
	 fqhostname,
	 cpucount
       from
	 dbamon.instances
       where
	 cpucount is not null
         and dbamonmode like '${mode}%') a
    group by
      dbms
  ";
  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=1 bgcolor=linen> \n";
  print "<tr bgcolor=slate>
    <th><font size=2>DBMS
    <th><font size=2>Total Server Count
    <th><font size=2>Total CPU Count
  \n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $dbms        = $Data[0];
    $servercount = $Data[1];
    $cpucount    = $Data[2];

    $total_server_count += $servercount;
    $total_cpu_count    += $cpucount;

    print "<tr>
      <td><font size=2>$dbms</font>
      <td align=right><font size=2>$servercount</font>
      <td align=right><font size=2>$cpucount</font>
    \n";
  }

  print "<tr bgcolor=slate>
    <td><b><font size=2>Total:<font>
    <td align=right><font size=2><b>$total_server_count</b></font>
    <td align=right><font size=2><b>$total_cpu_count</b></font>
  \n";
  print "</table> \n";
}

#-----------------------------------------------------------------------------
sub report_oradbs
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "select
     trim(misc3) m3,
     trim(system) || '_' || trim(instance) inst,
     trim(dbmsver) ver,
     misc1
   from
     dbamon.instances
   where
     dbamonmode like 'prod%'
     and dbms = 'Oracle'
     and misc3 is not null
     --and misc1 = 'bkRMAN' and dbmsver like '8.1%'
   order by 1, 2
      ";
  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=0> \n";
  print "<tr bgcolor=slate><th>DBID<th>Instance<th>Oracle Version<th>Backup Type<th>Duplicate?\n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $dbid     = $Data[0];
    $instance = $Data[1];
    $ver      = $Data[2];
    $bktype   = $Data[3];

    if ($dbid eq $last_dbid)
    {
      $msg = "<b><font color=red>Duplicate</b></font>"; 
    }
    else
    {
      $msg = ""; 
    }

    print "<tr ><td><b>$dbid <td>$instance <td>$ver <td>$bktype <td>$msg\n";

    $last_dbid = $dbid;
  }

  print "<tr ><td colspan=3><hr> \n";
  print "Total Oracle/UX Instances: $total \n";
  
  print "</table> \n";
}


#-----------------------------------------------------------------------------
sub report_oraver7
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "select
     trim(system) || '_' || trim(instance) inst,
     trim(dbmsver) ver,
     dbms
   from
     dbamon.instances
   where
     dbamonmode like 'prod%'
     and dbms like 'Oracle%'
     and dbmsver like '7%'
   order by 1, 2
      ";
  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<table border=0> \n";
  print "<tr bgcolor=slate><th>Instance<th>Oracle Version<th>DBMS\n";
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $instance = $Data[0];
    $ver      = $Data[1];
    $dbms     = $Data[2];

    print "<tr ><td><b><font size=2>$instance <td><font size=2>$ver <td><font size=2>$dbms\n";
  }

  print "<tr ><td colspan=3><hr> \n";
  print "<font size=2>Total Oracle/UX Version 7 Instances: $total \n";
  
  print "</table> \n";
}


#-----------------------------------------------------------------------------
sub report_gov1
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  &msg("Selecting data from DBAMON.TICKET_GOVERNOR ...");

  system("echo '' | mailx -s 'monitor--$P ($ENV{'REMOTE_HOST'}) [AUTO]' bill_border\@thecompany.com");

  $date_format = "YYYYMMDD-HH24";
  $statement  = "
    select
      to_char(ts, '$date_format'),
      count(*)
    from
      dbamon.ticket_governor
    group by 
      to_char(ts, '$date_format')
    order by 
      to_char(ts, '$date_format')
    ";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = $Data[0];
    $count = $Data[1];
    $mrvalue = $count;
  }

  $date_format = "DDMONYYYY-HH24";

  $statement  = "
    select
      to_char(ts, '$date_format'),
      count(*)
    from
      dbamon.ticket_governor
    group by
      to_char(ts, '$date_format')
    order by 
      to_char(ts, '$date_format')
    ";

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  &msg("Done selecting data...");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $total++;
    $ts    = $Data[0];
    $count = $Data[1];

    $tsout = "${ts}:00";
    $sasdata .= "$tsout $count\n";

  }

  $tmpsaspgm = "/tmp/${P}_${$}_saspgm.sas";
  $tmpsaslst = "/tmp/${P}_${$}_saspgm.lst";
  $tmpsaslog = "/tmp/${P}_${$}_saspgm.log";
  $tmpsasgif = "/tmp/${P}_${$}_saspgm.gif";
  $wwwsasgif = "/opt/web/dba/tmp/${P}_${$}_saspgm.gif";

  $saspgm = "
      data w1;
      format
        ts datetime7.
        ; 
      input 
        ts datetime15. 
        count 9.
        ;
      cards;
$sasdata
    ;

    proc sort;
      by ts;

    /*
    option pagesize=60 linesize=80 ;
    proc print;
    run;
    */

  goptions
    device=imggif
    gaccess=sasgastd
    gsfname=grafout
    gsfmode=replace
    ;
  run;

  %let font     = simplex;
  %let color    = blue;
  filename grafout '$tmpsasgif';
  run;

proc gplot;

  symbol i=join;

  symbol1 w=1 c=green  i=sm50 v=none;
  symbol2 w=1 c=red    i=join v=none;
  symbol3 w=1 c=yellow i=join v=none;
  symbol4 w=1 c=blue  i=join v=none;
  symbol5 w=1 c=purple i=join v=none;
  symbol6 w=1 c=cyan   i=join v=none;
  symbol7 w=1 c=red    i=join v=none;
  symbol8 w=1 c=white   i=join v=none;
  symbol9 w=1 c=green   i=join v=plus;
  symbol10 w=1 c=red    i=join v=plus;
  symbol11 w=1 c=yellow i=join v=plus;
  symbol12 w=1 c=blue   i=join v=plus;
  symbol13 w=1 c=purple i=join v=plus;
  symbol14 w=1 c=cyan   i=join v=plus;
  symbol15 w=1 c=red    i=join v=plus;
  symbol16 w=1 c=white  i=join v=plus;

  axis1 label = (c=black  h=1.4 f=&font)
        value = (f=&font)
        ;

  axis2 label = (c=black  h=1.4 a=90 r=0 f=&font)
        value = (f=&font)
        ;

  title1 f=&font c=darkblue h=2.5 'DBAmon Ticket Rate - By Date/Hour';
  title2 f=&font c=darkblue h=1.7 'Most Recent Value: $mrvalue Tickets/Hour';
  footnote1 f=&font c=red h=1.7 'Ticket Governor is Invoked at 100 Tickets/Hour';

  label count  = 'Sample Ticket Rate (Tickets/Hour)';
  label ts     = 'Timestamp';
  
  plot
    count*ts = 4
    count*ts = 1
       /
         overlay
         grid
         vzero
         haxis = axis1
         vaxis = axis2
         vminor=1
         hminor=1
         cframe = skyblue
        vref=100
       cvref=red
       lvref=2
         ;
    ";

  ##&msg("saspgm=<pre>$saspgm</pre>");

  open(SASPGM, ">$tmpsaspgm") || &error("Cannot open output $tmpsaspgm - $!");
  print SASPGM "$saspgm";
  close(SASPGM);

  &msg("Invoking SAS");

  $rc = system("cd /tmp;/opt/sas1/sas -work /tmp $tmpsaspgm 2>&1");

  &msg("Back from SAS - rc=$rc");

  ##print "<pre><font size=2></center>\f";
  ##system("cat $tmpsaslst | sed 's/</{/g'");
  ##system("cat $tmpsaslog | sed 's/</{/g'");
  ##print "</pre>";

  system("cp $tmpsasgif $wwwsasgif");
  print "<hr><img src='/dba/tmp/${P}_${$}_saspgm.gif'><hr>";
  &msg("Graph file: /dba/tmp/${P}_${$}_saspgm.gif");
}

#-----------------------------------------------------------------------------
sub report_instsum
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $rc = $dbh->do("drop table z1");

  $statement  = "
    create table z1 as
    select
      distinct
	substr(zdate,1,7) wdate,
	upper(dbms) dbms,
	instance
    from
      dbamon.history
    where 
      dbamonmode = '$dbamonmode'";
  $rc = $dbh->do("$statement") || &displayError('Failed_on_DB_do_delete');

  $statement  = "select
      wdate,
      dbms,
      count(*)
    from
      z1
    group by
      wdate,
      dbms ";
  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;
  print "<center><table border=0> \n";
  print "<tr bgcolor=slate><th>Month<th>DBMS/Appl.<th>Instance Count\n";
  while (@Data = $sth->fetchrow_array)
  {
    $wdate    = $Data[0];
    $dbms     = $Data[1];
    $count    = $Data[2];
    

    if ($wdate ne $last_wdate && $flag == 1)
    {
      print "<tr bgcolor=skyblue><td colspan=2><b>Total For Month:<td align=right><b>$running_total \n";
      print "<tr ><td colspan=3><hr> \n";
      $running_total = 0;
    }
    else
    {
    }

    $flag = 1;

    print "<tr ><td>$wdate <td>$dbms <td align=right><b>$count \n";
    $last_wdate = $wdate;
    $running_total += $count;
  }

      print "<tr bgcolor=skyblue><td colspan=2><b>Total For Month:<td align=right><b>$running_total \n";
      print "<tr ><td colspan=3><hr> \n";
  
  print "</table></center> \n";
}

#-----------------------------------------------------------------------------
sub report_uptime1
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $statement  = "select
      to_char(tot_date,\'YYYY/MM/DD\') ,
      tot_downtime,
      tot_pct
    from
      dbamon.uptime_summary
    where 
      instance = '$arg1'
    order by
      1 ";
  ##print "statement=$statement \n";
  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $count = 0;
  print "<center><table border=0> \n";
  print "<tr bgcolor=slate><th>Date<th>Instance<br>Downtime<br> (Minutes)<th>Daily<br>Uptime<br> %<th>Histogram\n";
  while (@Data = $sth->fetchrow_array)
  {
    $date     = $Data[0];
    $downtime = int($Data[1]/60);
    $pct      = sprintf("%5.1f",$Data[2]);
    
    $hist = "*" x int($pct/3);
    #$hist = "&gt;" x int($pct/3);
    #$hist = "&curren;" x int($pct/3);
    if    ($pct >= 99) { $c = "green"; }
    elsif ($pct >= 95) { $c = "yellow"; }
    else               { $c = "red"; }

    print "<tr ><td><b>$date <td align=right>$downtime <td align=right><b>$pct <td><font color=$c><b>$hist</b></font>  \n";
    $count++; 
    $t_pct += $pct;
    $t_downtime += $downtime;
  }

  if ($count > 0)
  {
    $m_pct = sprintf("%5.1f",$t_pct / $count);
  }
  $hist = "*" x int($m_pct/3);
  print "<tr bgcolor=slate><th>Total:<td align=right>$t_downtime <td align=right><b>$m_pct <td bgcolor=white><font color=$c><b>$hist</b></font>  \n";

  print "</table> \n";
  print "<p><b>Histogram Color Legend:</b>\n";
  print "<br><font color=green><b>Pct >= 99%</b></font>\n";
  print "<br><font color=yellow><b>Pct >= 95%</b></font>\n";
  print "<br><font color=red><b>Pct < 95%</b></font>\n";
  print "</center> \n";
  if ($count == 0)
  {
    print "<b>Note:</b> No rows retrieved. There is only uptime data for Oracle8 and higher\n";
  }
}

#-----------------------------------------------------------------------------
sub report_uptime2
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  $statement  = "select
      to_char(tot_date,\'MM,DD,YYYY') ,
      tot_downtime,
      tot_pct
    from
      dbamon.uptime_summary
    where 
      instance = '$arg1'
      and tot_date >= sysdate - 30
    order by
      1 ";
  ##print "statement=$statement \n";
  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  print '<script language="JavaScript1.2" SRC="/dbamon/javagraph/my_graph.js"></script>';

  $count = 0;

  #print "<center><table border=0> \n";
  #print "<tr bgcolor=slate><th>Date<th>Instance<br>Downtime<br> (Minutes)<th>Daily<br>Uptime<br> %<th>Histogram\n";

  while (@Data = $sth->fetchrow_array)
  {
    $date     = $Data[0];
    $downtime = int($Data[1]/60);
    $pct      = sprintf("%5.1f",$Data[2]);
    
    $sdate = $date if $sdate eq "";

    $hist = "*" x int($pct/3);
    #$hist = "&gt;" x int($pct/3);
    #$hist = "&curren;" x int($pct/3);
    if    ($pct >= 99) { $c = "green"; }
    elsif ($pct >= 95) { $c = "yellow"; }
    else               { $c = "red"; }

    #print "<tr ><td><b>$date <td align=right>$downtime <td align=right><b>$pct <td><font color=$c><b>$hist</b></font>  \n";

    $pcts .= "$pct,";
    
    $count++; 
    $t_pct += $pct;
    $t_downtime += $downtime;
  }
  chop $pcts;
  ##print "pcts=$pcts\n<hr>";
  print "
<script language='JavaScript1.2'>
var g = new Graph(725,250);
g.path = 'http://$hostname/dbamon/javagraph/';
g.xLabel = 'Date';
g.yLabel = '%';
g.scale = 25;
g.skip = 10;
g.title = 'Uptime % By Date - $arg1';
g.setDate($sdate);
g.addRow($pcts);
g.build();
</script><hr>
  ";

  if ($count > 0)
  {
    $m_pct = sprintf("%5.1f",$t_pct / $count);
  }
  $hist = "*" x int($m_pct/3);
  print "<b>Date Range: </b> $sdate <b> Through: </b> $date ($count Days)\n";
  print "<br><b>Total Downtime Minutes During Last 30 Days:</b> $t_downtime \n";
  print "<br><b>Total Downtime Percentage During Last 30 Days:</b> $m_pct \n";

  if ($count == 0)
  {
    print "<b>Note:</b> No rows retrieved. There is only uptime data for Oracle8 and higher\n";
  }
}

#-----------------------------------------------------------------------------
sub report_id1dbms
#-----------------------------------------------------------------------------
{
  chop($d = `date`);
  print "<font size=1>$d - Creating Report ...</font>\n";

  # Get totals by ID1 value

  $statement  = "
    select
      misc2,
      count(*) 
    from 
      dbamon.instances
    where
      dbamonmode like 'prod%'
    group by
      misc2 ";

  $sth = $dbh->prepare($statement) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);

  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $id1      = $Data[0];
    $count    = $Data[1];

    $id1 = "[Null]" if $id1 eq "";
    $id1total{$id1} = $count;
    ##print "$id1=$id1total{$id1} \n";
  }

  $statement  = "
    select
      misc2,
      dbms,
      count(*) 
    from 
      dbamon.instances
    where
      dbamonmode like 'prod%'
    group by
      misc2,
      dbms
    ";

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  chop($d = `date`);
  print "<br><font size=1>$d - Report Complete ...</font><hr>\n";

  $selectcount = 0;

  print "<center><table border=0> \n";
  print "<tr bgcolor=slate><th>ID1 Value<th>DBMS/Appl.<th>Instance Count<th>% of ID1<br>Total<br>Instances\n";

  while (@Data = $sth->fetchrow_array)
  {
    $id1      = $Data[0];
    $dbms     = $Data[1];
    $count    = $Data[2];

    $selectcount++;

    $id1 = "[Null]" if $id1 eq "";

    if ($id1 ne $last_id1 && $flag == 1)
    {
      print "<tr bgcolor=skyblue><td colspan=2><b>Instance Total For ID1=$last_id1:<td align=right><b>$running_total \n";
      print "<tr ><td colspan=3><hr> \n";
      $running_total = 0;
    }
    else
    {
    }

    $flag = 1;

    $pct = $count / $id1total{$id1};
    $pct = sprintf("%5.1f",$pct*100);

    print "<tr ><td>$id1 <td>$dbms <td align=right><b>$count <td align=right>${pct}% \n";
    $last_id1 = $id1;
    $running_total += $count;
    $grand_total += $count;
  }

  print "<tr bgcolor=skyblue><td colspan=2><b>Instance Total For ID1=$id1:<td align=right><b>$running_total \n";
  print "<tr ><td colspan=3><hr> \n";
  
  print "<tr bgcolor=skyblue><td colspan=2><b>All ID1 Values Total:<td align=right><b>$grand_total \n";
  print "<tr ><td colspan=3><hr> \n";

  print "</table></center> \n";
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  #local($Signal) = @_;
  exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#------------------------------------------------------------------------------
sub CheckForEvilness
#------------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

chdir("/opt/dbamon/htm/javagraph/");
system("env > /tmp/env");

$SaveFile = "/tmp/dbamon_rpt_vd.log";
unlink($SaveFile);
chop($CurrentDate = `date`);

&get_request;
print "Content-type: text/html\n\n";

chop($hostname = `hostname`);

@words = split(/,/,$ARGV[0]);
$dbamonmode = $words[0];
$report     = $words[1];
$arg1       = $words[2];

$title = "Count of Instances By DBMS/Appl. And Month" if $report eq "instsum";
$title = "Oracle/UX DB's By DBID" if $report eq "oradbs";
$title = "Count of Instances By ID1 and DBMS" if $report eq "id1dbms";
$title = "Unplanned Downtime By Date" if $report eq "uptime1";
$title = "Recently Modified Notepad Entries" if $report eq "text";
$title = "Server and CPU Count by DBMS" if $report eq "cpucount";

#print "dbamonmode=$dbamonmode report=$report title=$title \n"; exit;

open(LOG, ">>$SaveFile" );
print LOG "$P $CurrentDate : \n";

print "
<title>DBAmon Report: $report $arg1</title>
<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
<table width=700><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=700>
<tr bgcolor=wheat><td><font face=$font size=5>
    <center><img src='/dbamon/img/dbamon_graphs.gif'> DBAmon Report: $report - $arg1 <br> $title</center>
</table>
<hr>";

#print "<body bgcolor=white><font face=$font>\n";
#print "<title>DBAmon Report - $title</title>\n";
#print "<center><h2>DBAmon Report - $report</h2>\n";
#print "<h3><font color=darkblue>$title</font></h3>\n";
#print "<b>As Of: $CurrentDate</b><hr></center>\n";

# Connect to DB
&connectDB;

if    ($report eq "instsum")    { &report_instsum(); }
elsif ($report eq "oradbs")     { &report_oradbs(); }
elsif ($report eq "oraver7")    { &report_oraver7(); }
elsif ($report eq "oraserverstxt") { &report_oraservers_text(); }
elsif ($report eq "id1dbms")    { &report_id1dbms(); }
elsif ($report eq "uptime1")    { &report_uptime1(); }
elsif ($report eq "uptime2")    { &report_uptime2(); }
elsif ($report eq "text")       { &report_text(); }
elsif ($report eq "gov1")       { &report_gov1(); }
elsif ($report eq "cpucount")   { &report_cpucount(); }

else
{
  print "Mode=$dbamonmode Report=$report Arg1=$arg1 \n";
  print "<br><b>Error:</b> Report $report is not defined.";
}

print "<hr><font size=2>Done - Click <b>Back</b>.";

close(LOG);
exit 0;
