#-----------------------------------------------------------------------------
sub verifyTables
#-----------------------------------------------------------------------------
{
  #---- Process each table definition in /opt/dbamon/sql

  if ($repos eq "O") { $table_create_dir = "/opt/dbamon/sql_oracle/"; }
  else               { $table_create_dir = "/opt/dbamon/sql_mssql/"; }
  &logit("Verifying that all DBAmon repository tables exists - table_create_dir=$table_create_dir");

  opendir(IN_DIR, "$table_create_dir") || &error_msg("Cannot opendir $table_create_dir - $!");
  @in_files = readdir IN_DIR;
  closedir(IN_DIR); 
  foreach $verify_file (@in_files)
  {
    if ($verify_file =~ /^table_/)
    {
      $z = length($verify_file) - 10;
      $table = uc substr($verify_file,6,$z);
      ##&logit("  DEBUG Found table definition file=$verify_file table=$table");
      if (&verifyTablesCount("$table") != 1)
      {
        &verifyTablesCreate("$table");
        &error("Failed to create table=$table", "", "", "Y") if (&verifyTablesCount("$table") != 1);
      }
    }
  }

  #---- Alter TABLES every iteration (the add of columns there is conditional)
  if (-e "$table_create_dir/alter_dbamon_tables.sql") 
  {
    my $altersql = ""; 
    open(ALTERFILE, "$table_create_dir/alter_dbamon_tables.sql") || &error_msg("Cannot open input alter_dbamon_tables.sql"); 
    while(<ALTERFILE>) 
    {
      $altersql .= $_; 
    }
    close(ALTERFILE); 
    
    &logit("Executing ALTER statements found in $table_create_dir/alter_dbamon_tables.sql"); 
    ##&logit("altersql=$altersql"); 
    $sth = $dbh->do($altersql) || &error("alter_tables");
  }
}

#-----------------------------------------------------------------------------
sub verifyTablesCount
#-----------------------------------------------------------------------------
{
  my $this_table = uc $_[0];

  if ($repos eq "O")
  {
  $sql  = "
    select
      count(*)  
    from
      user_tables
    where
      table_name = '$this_table' 
  ";
  }
  else
  {
    $sql = "
    select 
      count(*)  
    from INFORMATION_SCHEMA.TABLES 
    where TABLE_SCHEMA = 'dbamon' and TABLE_NAME = '$this_table'; 
    "; 
  }
  ##print "sql=$sql\n";
  $sth = $dbh->prepare($sql) || &error_msg('Select_$what');
  $sth->execute || &error_msg('Failed_on_DB_execute_in_chgEnt');
  $count = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $count = $Data[0];
  }

  if ($debug_37)
  {
    if ($count == 1) { $zmsg = "Table DOES Exist"; }
    else             { $zmsg = "Table Does NOT Exist"; }
    &logit("  verifyTablesCount - Table $this_table count=$count - $zmsg");
  }

  return $count;
}

#-----------------------------------------------------------------------------
sub verifyTablesCreate
#-----------------------------------------------------------------------------
{
  my $this_table = uc $_[0];
  &logit("  Creating table $this_table"); 

  if ($repos eq "O")  #---- Oracle repos
  {
    $rc = system("sqlplus dbamon/$oracle_password <<! > $tmpfl3 2>&1
      \@$table_create_dir/$verify_file ; 
      exit
    !");
    #---- Copy output to log
    system("cat $tmpfl3 >> /opt/dbamon/log/verifyTables.log"); 
    if ($rc != 0)
    {
      system("cat $tmpfl3 2>&1"); 
      &error_msg("Error creating table $this_table - $!", "", "", "Y"); 
    }
  }
  else #---- MSSQL repos
  {
    $sql = `cat $table_create_dir/$verify_file`; 
    &logit("Creating MSSQL table $table - sql=$sql"); 
    
    $sth = $dbh->do($sql) || &error("Use_DBAMON");
  }
}

1;
